summaryrefslogtreecommitdiffstats
path: root/utils
diff options
context:
space:
mode:
authorAric Gardner <agardner@linuxfoundation.org>2015-09-10 11:08:28 -0400
committerAric Gardner <agardner@linuxfoundation.org>2015-09-10 11:41:46 -0400
commitc2ed9c64db2ca84ea599b4c5231d24bbf06547ed (patch)
tree64a968e178abbdae6f94b435f73059a7fbbf199d /utils
parentab033ff8befb4f7702af7af4c5f63bd4de11eb37 (diff)
Add document generation job for dovetail project
Moved docu-build-new.sh to utils. hoping I can include it from here to avoid duplication Change-Id: I80359036c954e70268b1a3e63c9b0855551be710 Signed-off-by: Aric Gardner <agardner@linuxfoundation.org>
Diffstat (limited to 'utils')
-rwxr-xr-xutils/docu-build-new.sh109
1 files changed, 109 insertions, 0 deletions
diff --git a/utils/docu-build-new.sh b/utils/docu-build-new.sh
new file mode 100755
index 000000000..00d046479
--- /dev/null
+++ b/utils/docu-build-new.sh
@@ -0,0 +1,109 @@
+#!/bin/bash
+set -e
+set -o pipefail
+
+export PATH=$PATH:/usr/local/bin/
+git_sha1="$(git rev-parse HEAD)"
+
+clean() {{
+if [[ -d docs/output ]]; then
+rm -rf docs/output
+echo "cleaning up output directory"
+fi
+}}
+
+trap clean EXIT TERM INT SIGTERM SIGHUP
+
+#set git_sha1
+files=()
+while read -r -d ''; do
+ files+=("$REPLY")
+done < <(find docs/ -type f -iname '*.rst' -print0)
+for file in "${{files[@]}}"; do
+ sed -i "s/_sha1_/$git_sha1/g" $file
+done
+
+directories=()
+while read -d $'\n'; do
+ directories+=("$REPLY")
+done < <(find docs/ -name 'index.rst' -printf '%h\n' | sort -u )
+
+for dir in "${{directories[@]}}"; do
+ echo
+ echo "#############################"
+ echo "Building DOCS in ${{dir##*/}}"
+ echo "#############################"
+ echo
+
+ if [[ ! -d docs/output/"${{dir##*/}}/" ]]; then
+ mkdir -p docs/output/"${{dir##*/}}/"
+ fi
+
+ sphinx-build -b html -E -c docs/etc/ ""$dir"/" docs/output/"${{dir##*/}}/"
+
+done
+
+# NOTE: make sure source parameters for GS paths are not empty.
+[[ $GERRIT_CHANGE_NUMBER =~ .+ ]]
+[[ $GERRIT_PROJECT =~ .+ ]]
+[[ $GERRIT_BRANCH =~ .+ ]]
+
+gs_path_review="artifacts.opnfv.org/review/$GERRIT_CHANGE_NUMBER"
+
+if [[ $GERRIT_BRANCH = "master" ]] ; then
+ gs_path_branch="artifacts.opnfv.org/$GERRIT_PROJECT"
+else
+ gs_path_branch="artifacts.opnfv.org/$GERRIT_PROJECT/${{GERRIT_BRANCH##*/}}"
+fi
+
+for dir in "${{directories[@]}}"; do
+ echo
+ echo "#############################"
+ echo "UPLOADING DOCS in ${{dir##*/}}"
+ echo "#############################"
+ echo
+
+
+ if [[ $JOB_NAME =~ "verify" ]] ; then
+
+ #upload artifacts for verify job
+ gsutil cp -r docs/output/"${{dir##*/}}/" "gs://$gs_path_review/"
+
+ # post link to gerrit as comment
+ gerrit_comment="$(echo '"Document is available at 'http://$gs_path_review/"${{dir##*/}}"/index.html' for review"')"
+ echo "$gerrit_comment"
+ ssh -p 29418 gerrit.opnfv.org gerrit review -p $GERRIT_PROJECT -m \
+ "$gerrit_comment" $GERRIT_PATCHSET_REVISION
+
+ #set cache to 0
+ for x in $(gsutil ls gs://$gs_path_review/"${{dir##*/}}" | grep html);
+ do
+ gsutil setmeta -h "Content-Type:text/html" \
+ -h "Cache-Control:private, max-age=0, no-transform" \
+ "$x"
+ done
+
+ else
+
+ #upload artifacts for merge job
+ gsutil cp -r docs/output/"${{dir##*/}}" "gs://$gs_path_branch/docs/"
+ echo "Latest document is available at http://$gs_path_branch/docs/"${{dir##*/}}"/index.html"
+
+ #set cache to 0
+ for x in $(gsutil ls gs://$gs_path_branch/"${{dir}}" | grep html);
+ do
+ gsutil setmeta -h "Content-Type:text/html" \
+ -h "Cache-Control:private, max-age=0, no-transform" \
+ "$x"
+ done
+
+ #Clean up review when merging
+ if gsutil ls "gs://$gs_path_review" > /dev/null 2>&1 ; then
+ echo
+ echo "Deleting Out-of-dated Documents..."
+ gsutil rm -r "gs://$gs_path_review"
+ fi
+
+ fi
+
+done